package cn.com.infosec.mobile.android.framework.crypto;

import cn.com.infosec.asn1.ASN1Encodable;
import cn.com.infosec.asn1.ASN1InputStream;
import cn.com.infosec.asn1.ASN1Sequence;
import cn.com.infosec.asn1.DERInteger;
import cn.com.infosec.asn1.DERObjectIdentifier;
import cn.com.infosec.asn1.DERSequence;
import cn.com.infosec.asn1.pkcs.PKCSObjectIdentifiers;
import cn.com.infosec.asn1.pkcs.RSAPrivateKeyStructure;
import cn.com.infosec.asn1.x509.AlgorithmIdentifier;
import cn.com.infosec.asn1.x509.RSAPublicKeyStructure;
import cn.com.infosec.asn1.x509.SubjectPublicKeyInfo;
import cn.com.infosec.mobile.android.framework.crypto.impl.gm.SM2Util;
import cn.com.infosec.mobile.android.framework.crypto.impl.gm.SM3Digest;
import java.io.ByteArrayInputStream;
import java.io.File;
import java.io.FileInputStream;
import java.math.BigInteger;
import java.security.KeyFactory;
import java.security.MessageDigest;
import java.security.PublicKey;
import java.security.cert.CertificateFactory;
import java.security.cert.X509CRL;
import java.security.cert.X509Certificate;
import java.security.spec.RSAPublicKeySpec;
import java.security.spec.X509EncodedKeySpec;
import java.util.Date;
import java.util.Random;
import javax.crypto.Cipher;
import javax.crypto.KeyGenerator;
import javax.crypto.spec.SecretKeySpec;

public class CipherUtil {
   private static final String RC4 = "RC4";

   public static byte[] sm2PublicKeyToByte(PublicKey pk) {
      Exception var10000;
      label37: {
         byte[] var9;
         boolean var10001;
         try {
            var9 = pk.getEncoded();
         } catch (Exception var5) {
            var10000 = var5;
            var10001 = false;
            break label37;
         }

         byte[] pk1 = var9;

         ByteArrayInputStream var10;
         try {
            var10 = new ByteArrayInputStream;
         } catch (Exception var4) {
            var10000 = var4;
            var10001 = false;
            break label37;
         }

         ByteArrayInputStream var1 = var10;

         ASN1Sequence var11;
         try {
            var10.<init>(pk1);
            var11 = (ASN1Sequence)(new ASN1InputStream(var1)).readObject();
         } catch (Exception var3) {
            var10000 = var3;
            var10001 = false;
            break label37;
         }

         ASN1Sequence pk2 = var11;

         try {
            return (new SubjectPublicKeyInfo(pk2)).getPublicKeyData().getBytes();
         } catch (Exception var2) {
            var10000 = var2;
            var10001 = false;
         }
      }

      Exception pk3 = var10000;
      throw new CryptoException(pk3);
   }

   public static PublicKey getPublicKey(String alg, byte[] pubKey) {
      Exception var10000;
      label57: {
         boolean var14;
         boolean var10001;
         try {
            var14 = "RSA".equalsIgnoreCase(alg);
         } catch (Exception var8) {
            var10000 = var8;
            var10001 = false;
            break label57;
         }

         if (var14) {
            label59: {
               ASN1InputStream var15;
               try {
                  var15 = new ASN1InputStream;
               } catch (Exception var5) {
                  var10000 = var5;
                  var10001 = false;
                  break label59;
               }

               ASN1InputStream alg1 = var15;

               RSAPublicKeyStructure var16;
               try {
                  var15.<init>(new ByteArrayInputStream(pubKey));
                  var16 = new RSAPublicKeyStructure;
               } catch (Exception var4) {
                  var10000 = var4;
                  var10001 = false;
                  break label59;
               }

               RSAPublicKeyStructure pubKey1 = var16;

               KeyFactory var17;
               RSAPublicKeySpec var18;
               RSAPublicKeySpec var10002;
               RSAPublicKeyStructure var10003;
               BigInteger var10004;
               try {
                  var16.<init>((DERSequence)alg1.readObject());
                  var17 = KeyFactory.getInstance("RSA", "INFOSEC");
                  var18 = new RSAPublicKeySpec;
                  var10002 = var18;
                  var10003 = pubKey1;
                  var10004 = pubKey1.getModulus();
               } catch (Exception var3) {
                  var10000 = var3;
                  var10001 = false;
                  break label59;
               }

               BigInteger alg2 = var10004;

               try {
                  var10002.<init>(alg2, var10003.getPublicExponent());
                  return var17.generatePublic(var18);
               } catch (Exception var2) {
                  var10000 = var2;
                  var10001 = false;
               }
            }
         } else {
            label60: {
               String var19;
               X509EncodedKeySpec var20;
               try {
                  var19 = alg;
                  var20 = new X509EncodedKeySpec;
               } catch (Exception var7) {
                  var10000 = var7;
                  var10001 = false;
                  break label60;
               }

               X509EncodedKeySpec alg3 = var20;

               try {
                  var20.<init>(pubKey);
                  return KeyFactory.getInstance(var19, "INFOSEC").generatePublic(alg3);
               } catch (Exception var6) {
                  var10000 = var6;
                  var10001 = false;
               }
            }
         }
      }

      Exception alg4 = var10000;
      throw new CryptoException(alg4);
   }

   public static byte[][] packageKeyPair(byte[][] bsKeyPair, String RSAorSM2) {
      byte[][] var2 = new byte[2][];
      byte[] RSAorSM21;
      byte[] var19;
      if (RSAorSM2.equalsIgnoreCase("SM2")) {
         (RSAorSM21 = new byte[65])[0] = 4;

         int var3;
         int var4;
         for(var3 = 0; var3 < 32; var3 = var4) {
            var4 = var3 + 1;
            RSAorSM21[var4] = bsKeyPair[0][var3];
         }

         for(var3 = 0; var3 < 32; ++var3) {
            var4 = var3 + 33;
            RSAorSM21[var4] = bsKeyPair[0][var3 + 32];
         }

         AlgorithmIdentifier var15;
         AlgorithmIdentifier var10000 = var15 = new AlgorithmIdentifier;
         DERObjectIdentifier var16;
         var16 = new DERObjectIdentifier.<init>("1.2.840.10045.2.1");
         DERObjectIdentifier var5;
         var5 = new DERObjectIdentifier.<init>("1.2.156.10197.1.301");
         var10000.<init>(var16, var5);
         RSAorSM21 = (new SubjectPublicKeyInfo(var15, RSAorSM21)).getEncoded();
         byte var17 = 64;
         var19 = new byte[64];

         for(int var21 = 0; var21 < var17; ++var21) {
            var19[var21] = 0;
         }

         System.arraycopy(bsKeyPair[1], 0, var19, 32, 32);
         var2[0] = RSAorSM21;
         var2[1] = var19;
      } else if (RSAorSM2.equalsIgnoreCase("RSA")) {
         RSAorSM21 = new byte[256];
         System.arraycopy(bsKeyPair[0], 4, RSAorSM21, 0, 256);
         byte[] var18;
         byte[] var10001 = var18 = new byte[3];
         var10001[0] = 1;
         var10001[1] = 0;
         var10001[2] = 1;
         ASN1Encodable[] var10003 = new ASN1Encodable[2];
         DERInteger var20;
         var20 = new DERInteger.<init>(RSAorSM21);
         var10003[0] = var20;
         DERInteger RSAorSM22;
         RSAorSM22 = new DERInteger.<init>(var18);
         var10003[1] = RSAorSM22;
         DERSequence var28 = new DERSequence(var10003);
         AlgorithmIdentifier RSAorSM23;
         RSAorSM23 = new AlgorithmIdentifier.<init>(PKCSObjectIdentifiers.rsaEncryption);
         var18 = var28.getEncoded();
         RSAorSM21 = (new SubjectPublicKeyInfo(RSAorSM23, var18)).getEncoded();
         var10001 = var18 = new byte[1152];
         byte[] var10009 = var19 = new byte[4];
         System.arraycopy(bsKeyPair[1], 0, var19, 0, 4);
         bytesToInt(var10009);
         System.arraycopy(bsKeyPair[1], 4, var18, 0, 1152);
         byte[] bsKeyPair1 = new byte[256];
         var18 = new byte[256];
         var19 = new byte[128];
         byte[] var22 = new byte[128];
         byte[] var6 = new byte[128];
         byte[] var7 = new byte[128];
         byte[] var8 = new byte[128];
         System.arraycopy(var10001, 0, bsKeyPair1, 0, 256);
         System.arraycopy(var10001, 256, var18, 0, 256);
         System.arraycopy(var10001, 512, var19, 0, 128);
         System.arraycopy(var10001, 640, var22, 0, 128);
         System.arraycopy(var10001, 768, var6, 0, 128);
         System.arraycopy(var10001, 896, var7, 0, 128);
         System.arraycopy(var10001, 1024, var8, 0, 128);
         BigInteger var10004 = new BigInteger(1, bsKeyPair1);
         BigInteger bsKeyPair2 = BigInteger.valueOf(65537L);
         BigInteger var9;
         var9 = new BigInteger.<init>(1, var18);
         BigInteger var23;
         var23 = new BigInteger.<init>(1, var19);
         BigInteger var24;
         var24 = new BigInteger.<init>(1, var22);
         BigInteger var25;
         var25 = new BigInteger.<init>(1, var6);
         BigInteger var26;
         var26 = new BigInteger.<init>(1, var7);
         BigInteger var27;
         var27 = new BigInteger.<init>(1, var8);
         RSAPrivateKeyStructure var29 = new RSAPrivateKeyStructure(var10004, bsKeyPair2, var9, var23, var24, var25, var26, var27);
         var2[0] = RSAorSM21;
         var2[1] = var29.getEncoded();
      }

      return var2;
   }

   public static byte[] hash(String alg, byte[] data) {
      if (alg.equalsIgnoreCase("SM3")) {
         byte[] alg1;
         byte[] var4 = alg1 = new byte[32];
         SM3Digest var10001 = new SM3Digest();
         var10001.update(data);
         var10001.digest(alg1);
         return var4;
      } else {
         try {
            MessageDigest var10000 = MessageDigest.getInstance(alg);
            var10000.update(data);
            return var10000.digest();
         } catch (Exception var2) {
            throw new RuntimeException(var2);
         }
      }
   }

   public static byte[] SM3WithId(byte[] data, byte[] sm2Id, PublicKey pk) {
      byte[] var10000 = sm2PublicKeyToByte(pk);
      byte[] pk1 = new byte[64];
      System.arraycopy(var10000, 1, pk1, 0, 64);
      byte[] var3;
      var10000 = var3 = new byte[32];
      SM3Digest var4;
      SM3Digest var10001 = var4 = new SM3Digest;
      var4.<init>();
      var4.update(SM2Util.getZA(sm2Id, pk1));
      var4.update(data);
      var10001.digest(var3);
      return var10000;
   }

   public static byte[] pkcs5padding(byte[] data, int blockSize) {
      int var2;
      int var3;
      int var10000 = var3 = ((var2 = data.length) / blockSize + 1) * blockSize;
      byte[] var10002 = data;
      data = new byte[var3];
      System.arraycopy(var10002, 0, data, 0, var2);
      byte blockSize1;
      if ((blockSize1 = (byte)((var10000 - var2) % blockSize)) == 0) {
         blockSize1 = 16;
      }

      --var3;

      while(var3 > var2 - 1) {
         data[var3] = blockSize1;
         --var3;
      }

      return data;
   }

   public static byte[] pkcs1Padding(byte[] data, int keybits, String signOrEnc) {
      byte[] var3;
      (var3 = new byte[keybits /= 8])[0] = 0;
      if ("SIGN".equalsIgnoreCase(signOrEnc)) {
         var3[1] = 1;

         for(int signOrEnc1 = 2; signOrEnc1 != keybits - data.length - 1; ++signOrEnc1) {
            var3[signOrEnc1] = -1;
         }
      } else {
         var3[1] = 2;
         byte[] signOrEnc2 = new byte[1];
         Random var4;
         var4 = new Random.<init>(System.currentTimeMillis());

         for(int var5 = 2; var5 != keybits - data.length - 1; ++var5) {
            do {
               var4.nextBytes(signOrEnc2);
            } while(signOrEnc2[0] == 0);

            var3[var5] = signOrEnc2[0];
         }
      }

      var3[keybits - data.length - 1] = 0;
      int data1 = keybits - data.length;
      keybits = data.length;
      System.arraycopy(data, 0, var3, data1, keybits);
      return var3;
   }

   public static byte[] pkcs1UnPadding(byte[] b) {
      int var1;
      for(var1 = 2; var1 < b.length && b[var1] != 0; ++var1) {
      }

      int var2;
      byte[] var3;
      byte[] var10000 = var3 = new byte[var2 = b.length - var1 - 1];
      System.arraycopy(b, var1 + 1, var3, 0, var2);
      return var10000;
   }

   public static byte[] genSymKey(int len) {
      KeyGenerator var10000 = KeyGenerator.getInstance("RC4", "INFOSEC");
      var10000.init(len);
      return var10000.generateKey().getEncoded();
   }

   public static byte[] symEncrpt(byte[] k, byte[] d) {
      byte[] var10000 = d;
      byte[] var10001 = d;
      byte[] var2;
      byte[] var10002 = var2 = new byte[8];
      (new Random()).nextBytes(var2);
      d = new byte[8 + d.length];
      System.arraycopy(var10002, 0, d, 0, 8);
      int var3 = var10001.length;
      System.arraycopy(var10000, 0, d, 8, var3);
      SecretKeySpec var4;
      var4 = new SecretKeySpec.<init>(k, "RC4");
      Cipher var5 = Cipher.getInstance("RC4", "INFOSEC");
      var5.init(1, var4);
      return var5.doFinal(d);
   }

   public static byte[] symDecrpt(byte[] k, byte[] e) {
      SecretKeySpec var2;
      var2 = new SecretKeySpec.<init>(k, "RC4");
      Cipher var10000 = Cipher.getInstance("RC4", "INFOSEC");
      var10000.init(2, var2);
      int e1;
      byte[] var5;
      byte[] var3 = var5 = new byte[e1 = (k = var10000.doFinal(e)).length - 8];
      System.arraycopy(k, 8, var5, 0, e1);
      return var3;
   }

   public static byte[] PBEencrypt(char[] k, byte[] d) {
      byte[] var10000 = d;
      byte[] var10001 = d;
      byte[] var10002 = d;
      d = new byte[8];
      (new Random()).nextBytes(d);
      byte[] var2 = new byte[32];
      SM3Digest var10003 = new SM3Digest();
      var10003.update((new String(k)).getBytes());
      var10003.digest(var2);
      int k1;
      byte[] var3 = new byte[k1 = var10002.length];
      int var4 = var10001.length;
      System.arraycopy(var10000, 0, var3, 0, var4);
      (new RC4(var2)).encrypt(var3);
      var10000 = var2 = new byte[8 + k1];
      System.arraycopy(d, 0, var2, 0, 8);
      System.arraycopy(var3, 0, var2, 8, k1);
      return var10000;
   }

   public static byte[] PBEdecrypt(char[] k, byte[] e) {
      byte[] var2 = new byte[8];
      int var3;
      byte[] var4;
      byte[] var10000 = var4 = new byte[var3 = e.length - 8];
      System.arraycopy(e, 0, var2, 0, 8);
      System.arraycopy(e, 8, var4, 0, var3);
      e = new byte[32];
      SM3Digest var10003 = new SM3Digest();
      var10003.update((new String(k)).getBytes());
      var10003.digest(e);
      System.arraycopy(var10000, 0, new byte[var3], 0, var3);
      (new RC4(e)).encrypt(var4);
      return var10000;
   }

   public static byte[] hmac(byte[] k, byte[] d) {
      SM3Digest var2;
      var2 = new SM3Digest.<init>();
      byte var3 = 64;
      byte[] var4 = new byte[64];
      byte[] var5 = new byte[64];

      int var6;
      for(var6 = 0; var6 < var3; ++var6) {
         var4[var6] = 54;
         var5[var6] = 92;
      }

      byte[] var10;
      if (k.length > var3) {
         var10 = new byte[32];
         var2.update(k);
         var2.digest(var10);
      } else {
         var10 = k;
      }

      k = new byte[var3];
      var6 = var10.length;
      System.arraycopy(var10, 0, k, 0, var6);

      for(var6 = var10.length; var6 < var3; ++var6) {
         k[var6] = 0;
      }

      var10 = new byte[var3];

      int var7;
      for(var7 = 0; var7 < var3; ++var7) {
         var10[var7] = (byte)((k[var7] ^ var4[var7]) & 255);
      }

      byte[] var10004 = d;
      byte[] var10005 = d;
      d = new byte[var3 + d.length];
      System.arraycopy(var10, 0, d, 0, var3);
      int var8 = var10005.length;
      System.arraycopy(var10004, 0, d, var3, var8);
      byte var9 = 32;
      var10 = new byte[32];
      var2.reset();
      var2.update(d);
      var2.digest(var10);
      d = new byte[var3];

      for(var7 = 0; var7 < var3; ++var7) {
         d[var7] = (byte)((k[var7] ^ var5[var7]) & 255);
      }

      k = new byte[96];
      System.arraycopy(d, 0, k, 0, var3);
      System.arraycopy(var10, 0, k, var3, var9);
      byte[] var10000 = d = new byte[32];
      var2.reset();
      var2.update(k);
      var2.digest(d);
      return var10000;
   }

   public static byte[] hmac(byte[] k, byte[] d, String hashAlg) {
      MessageDigest hashAlg1 = MessageDigest.getInstance(hashAlg, "INFOSEC");
      byte var3 = 64;
      byte[] var4 = new byte[64];
      byte[] var5 = new byte[64];

      int var6;
      for(var6 = 0; var6 < var3; ++var6) {
         var4[var6] = 54;
         var5[var6] = 92;
      }

      if (k.length > var3) {
         hashAlg1.update(k);
         k = hashAlg1.digest();
      }

      byte[] var10000 = k;
      byte[] var10001 = k;
      byte[] var10002 = k;
      k = new byte[var3];
      var6 = var10002.length;
      System.arraycopy(var10001, 0, k, 0, var6);

      for(var6 = var10000.length; var6 < var3; ++var6) {
         k[var6] = 0;
      }

      byte[] var11 = new byte[var3];

      for(int var7 = 0; var7 < var3; ++var7) {
         var11[var7] = (byte)((k[var7] ^ var4[var7]) & 255);
      }

      byte[] var10004 = d;
      byte[] var10005 = d;
      d = new byte[var3 + d.length];
      System.arraycopy(var11, 0, d, 0, var3);
      int var10 = var10005.length;
      System.arraycopy(var10004, 0, d, var3, var10);
      hashAlg1.reset();
      hashAlg1.update(d);
      d = hashAlg1.digest();
      var4 = new byte[var3];

      for(var6 = 0; var6 < var3; ++var6) {
         var4[var6] = (byte)((k[var6] ^ var5[var6]) & 255);
      }

      k = new byte[var3 + d.length];
      System.arraycopy(var4, 0, k, 0, var3);
      int d1 = d.length;
      System.arraycopy(d, 0, k, var3, d1);
      hashAlg1.reset();
      hashAlg1.update(k);
      return hashAlg1.digest();
   }

   public static byte[] intToBytes(int i) {
      byte[] var1;
      byte[] var10000 = var1 = new byte[4];
      var1[0] = (byte)(i & 255);
      var1[1] = (byte)(i >> 8 & 255);
      var1[2] = (byte)(i >> 16 & 255);
      var10000[3] = (byte)(i >> 24 & 255);
      return var10000;
   }

   public static int bytesToInt(byte[] b) {
      int var1 = 0;

      for(int var2 = 0; var2 < b.length; ++var2) {
         var1 += b[var2] << var2 * 8;
      }

      return var1;
   }

   public static Date checkRevoke(String crlFile, X509Certificate issuer, BigInteger sn) {
      IHSM var3 = HSM.getInst((String)null);
      if (crlFile != null && crlFile.length() != 0) {
         File var4;
         File var10000 = var4 = new File;
         var10000.<init>(crlFile);
         if (var10000.exists()) {
            X509CRL crlFile1;
            if ((crlFile1 = (X509CRL)CertificateFactory.getInstance("X.509", "INFOSEC").generateCRL(new FileInputStream(var4))).getNextUpdate() != null && crlFile1.getNextUpdate().getTime() < System.currentTimeMillis()) {
               throw new Exception("the ARL is EXPIRED");
            } else {
               IHSM var11 = var3;
               X509Certificate var10002 = issuer;
               byte[] issuer1 = crlFile1.getTBSCertList();
               byte[] var9 = crlFile1.getSignature();
               PublicKey var10 = var10002.getPublicKey();
               String var5 = crlFile1.getSigAlgOID();
               byte[] var10001 = issuer1;
               String issuer2 = SM2Id.getVerifyId("CERT");
               if (var11.verify(var10001, var9, var10, var5, issuer2)) {
                  if (crlFile1.getRevokedCertificate(sn) == null) {
                     return crlFile1.getNextUpdate();
                  } else {
                     throw new Exception("ca is REVOKED by it's parent");
                  }
               } else {
                  throw new Exception("the ARL May NOT correct (verify signature failed)");
               }
            }
         } else {
            throw new Exception("ARL file[" + crlFile + "] NOT found");
         }
      } else {
         throw new Exception("ARL file NOT set");
      }
   }

   public static int certValid(X509Certificate toBeChecked, X509Certificate issuer) {
      long var2 = System.currentTimeMillis();
      if (toBeChecked.getNotBefore().getTime() < var2 && var2 < toBeChecked.getNotAfter().getTime()) {
         if (issuer.getNotBefore().getTime() < var2 && var2 < issuer.getNotAfter().getTime()) {
            X509Certificate var10000 = toBeChecked;
            X509Certificate var10001 = issuer;
            X509Certificate var10002 = toBeChecked;
            byte[] toBeChecked1 = toBeChecked.getTBSCertificate();
            byte[] issuer1 = var10002.getSignature();
            PublicKey var7 = var10001.getPublicKey();
            String var3 = var10000.getSigAlgOID();
            IHSM var8 = HSM.getInst("");
            byte[] var9 = toBeChecked1;
            String toBeChecked2 = SM2Id.getVerifyId("CERT");
            return !var8.verify(var9, issuer1, var7, var3, toBeChecked2) ? -3 : 0;
         } else {
            return -2;
         }
      } else {
         return -1;
      }
   }

   public static byte[] publicKeyHash(PublicKey pk) {
      SubjectPublicKeyInfo var1;
      var1 = new SubjectPublicKeyInfo.<init>((ASN1Sequence)(new ASN1InputStream(new ByteArrayInputStream(pk.getEncoded()))).readObject());
      MessageDigest var10000 = MessageDigest.getInstance("SHA1", "INFOSEC");
      var10000.update(var1.getPublicKeyData().getBytes());
      return var10000.digest();
   }
}
